##!/usr/bin/env python3
import time
import paho.mqtt.client as mqttClient
from pyModbusTCP.client import ModbusClient
c = ModbusClient(host='192.168.0.6', port=502, auto_open=True, debug=True)

def on_connect(client, userdata, flags, rc):
        if rc == 0:
                print("Connected to broker")
                client.subscribe('paradigma/#')
        else:
                print("Connection failed")

def on_message(client, userdata, message):
    print(" Topic: " + message.topic + " Payload: " + str(message.payload))
    if  "warmwasser_ein" in message.topic:
        try:
            c.write_register(8,65)
            print ("Warmwasser ein.")
        except:
            pass
    if  "warmwasser_aus" in message.topic:
        try:
            c.write_register(8,0)
            print ("Warmwasser aus.")
        except:
            pass

def read_registers():
    vara = ['soll_vorlauf_hk1','soll_leistung_hk1','soll_trinkwasser','max_vorlauf_hk1','status_ww','status_hk1','status_solar','status_kessel','soll_kessel','betriebsart_hk1']
    varb =  ['2','5','8','9','34','36','39','41','45','48']
    x = -1
    for i in varb:
        try:
            x=x+1
            time.sleep(2)
            y = int(i)
            print ("Halte_Register " + i)
            mid = c.read_holding_registers(y,1)
            wert = str(mid)
            wert = wert.replace("[","")
            wert = wert.replace("]","")
            print ('Slave 1 Register ' + vara[x]+ ' ' + wert)
            if x < 4:
                client.publish("076-Solar/Paradigma_D/"+vara[x]+"/set", wert)
            if x > 3 and x <8:
                client.publish("076-Solar/Paradigma_E/"+vara[x]+"/set", wert)
            if x > 7:
                client.publish("076-Solar/Paradigma_C/"+vara[x]+"/set", wert)
        except:
            pass

def read_coils():
    vara = ['aussentemp','vorlauf_hk1','ruecklauf_hk1','ww_oben','rueckl_zirk','raumtemp','kollektor','vor_kessel','rueck_kessel']
    varb = ['0','1','2','3','6','9','11','12','13']
    x = -1
    for i in varb:
        try:
            x=x+1
            time.sleep(2)
            y = int(i)
            print ("Input_Register " + i)
            mid = c.read_input_registers(y,1)
            wert = str(mid)
            wert = wert.replace("[","")
            wert = wert.replace("]","")
            print ('Slave 1 Register ' + vara[x]+ ' ' + wert)
            if x < 4:
                client.publish("076-Solar/Paradigma_A/"+vara[x]+"/set", wert)
            if x > 3 and x <8:
                client.publish("076-Solar/Paradigma_B/"+vara[x]+"/set", wert)
            if x > 7:
                client.publish("076-Solar/Paradigma_C/"+vara[x]+"/set", wert)
        except:
            pass            
broker_address= "192.168.0.49"
port = 1883

client = mqttClient.Client("client_76_Paradigma")          
client.on_connect= on_connect    
client.connect(broker_address, port=port)     
client.loop_start()


try:
    while True:
        read_registers()
        time.sleep(5)
        read_coils()
        time.sleep(5)

except KeyboardInterrupt:
    print("exiting")
    client.loop_stop()
    sys.exit(0)
